#!/bin/bash
# uncomment for verbosity
#set -x

if [ $# -ne 2 ]; then
  echo "Usage: $0 image type "
  echo "type is either 'm2-plus' or 'pro'"
  exit 1
fi

if [ ! -r $1 ]; then
  echo "Input image $1 not readable/existing"
  exit 1
fi

# used a differen suffic for m2-plus u-boot
[ "$2" = "m2-plus" ] && v="m2p" || v="${2}"

out=${1/GENERICSD/BANANAPI-${2^^}}
uboot="u-boot-sunxi-with-spl-bananapi${v}.bin"

if [ ! -r ${uboot} ]; then
  echo "${uboot} not readable/existing"
  exit 1
fi

echo "Creating new image file ${out}"
cp -v "$1" "${out}"

ldev=$( losetup -f )
losetup -P ${ldev} ${out}

echo "Implementing ${uboot}"
dd if="${uboot}" of="${ldev}" bs=1024 seek=8

echo "Adding all exisiting banana-pi dtb-files"

tmp=/tmp/imgloop
[ -d "${tmp}" ] || mkdir -p "${tmp}"
mount "${ldev}p1" "${tmp}" 
cp -v sun*banana*.dtb "${tmp}/dtb/"
umount "${tmp}"
rmdir "${tmp}"

losetup -d ${ldev}
